#-------------------------------------------------------------------------------
# Name:        ImageToIndexAry
# Purpose:
#
# Author:      jwezorek
#
# Created:     16/02/2012
# Copyright:   (c) jwezorek 2012
# Licence:     <your licence>
#-------------------------------------------------------------------------------
#!/usr/bin/env python

def Convert( img ):
    (wd,hgt) = img.size
    dictColorToIndex = {}
    index = [0]  #This has to be a some kind of mutable container...

    def GetColorIndex(x,y):
        pixel = img.getpixel( (x,y) )

        # ignore alpha channel...
        if (len(pixel) == 4):
            pixel = (pixel[0],pixel[1],pixel[2])

        # if we don't have an index for this color
        # assign it one...
        if (pixel not in dictColorToIndex):
            dictColorToIndex[pixel] = index[0]
            index[0] += 1

        return dictColorToIndex[pixel]

    ary = [[GetColorIndex(x,y) for x in range( 0, wd )] for y in range(0, hgt)]
    dictIndexToColor = dict((k,v) for (k,v) in map( lambda (x,y): (y,x), dictColorToIndex.items() ))
    return (ary, dictIndexToColor, dictColorToIndex)